Leetcode 213. House Robber II dp

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

题目链接:https://leetcode.com/problems/house-robber-ii/

思路就是:nums[0]和nums[n-1]不能同时包含在答案里,所以2遍dp,

第一遍:nums[0]=0,这样不包含nums[0]

第二遍:nums[n-1]=0,这样不包含nums[n-1]

class Solution {
public:
    int rob(vector<int>& nums) {
     int n=nums.size();
        if(n==0)
            return 0;
        if(n==1)
            return nums[0];
        if(n==2)
            return max(nums[0],nums[1]);
        vector<int> dp(n+2,0);
        int t=nums[0],res=0;
        nums[0]=0;
        dp[0]=nums[0];
        dp[1]=max(nums[0],nums[1]);
        for(int i=2;i<n;i++)
        {
            dp[i]=max(dp[i-1],nums[i]+dp[i-2]);
        }
        res=dp[n-1];
        nums[0]=t;
        nums[n-1]=0;
        dp[0]=nums[0];
        dp[1]=max(nums[0],nums[1]);
        for(int i=2;i<n;i++)
        {
            dp[i]=max(dp[i-1],nums[i]+dp[i-2]);
        }
        return max(res,dp[n-1]);
    }
};

猜你喜欢

转载自blog.csdn.net/salmonwilliam/article/details/88423072
今日推荐